/*
 * Created on 16.01.2007
 */
package dsasolo;

import java.util.*;
import java.util.regex.*;

public class Abenteuer {
	
	String name;
	IO io;
	String[] anfang;
	String[] held;
	String[] ende;
	Abschnitt[] abschnitte;
	int gesamtpunkte;
	static String[][] werte = {{"vorname", "nachname", "gAP", "D", "S", "H",
				"MU", "KL", "IN", "CH", "FF", "GE", "KO", "KK",
				"LeP", "RS", "BE", "AT", "PA",
				"wuerfelTP", "zusatzTP"},
				{"Vorname", "Nachname", "Abenteuerpunkte", "Dukaten", "Silbertaler", "Heller",
                "Mut", "Klugheit", "Intuition", "Charisma", "Fingerfertigkeit", "Gewandheit", "Konstitution", "Krperkraft",
                "Lebensenergie", "Rstungsschutz", "Belastung", "Attacke", "Parade",
                "Anzahl der Wrfel", "Zusatz-TP"}};
	static String[] folgewerte = {"Stufe", "maxLeP", "Basiswert VW"};							
	static String[][] talente;
	static String[] variablen;
	
	public Abenteuer(){
		this.gesamtpunkte = 0;
	}
	
	static int wandleZahl(String zahl){
		try{
			zahl = zahl.trim();
			return Integer.parseInt(zahl);
		}catch(Exception e){
			return -1;
		}
	}
	
	static String wandleRoemischeZahl(int n) {
		String s = "";
		switch(n) {
			case 1:
				s = "I";
				break;
			case 2:
				s = "II";
				break;
			case 3:
				s = "III";
		}
		return s;
	}
	
	static String wandleString(String s){
		s = s.replaceAll("", "Ae");
		s = s.replaceAll("", "Oe");
		s = s.replaceAll("", "Ue");
		s = s.replaceAll("", "ae");
		s = s.replaceAll("", "oe");
		s = s.replaceAll("", "ue");
		s = s.replaceAll("", "ss");
		s = s.replaceAll("&", "");
		s = s.replaceAll("-", "");
		s = s.replaceAll(" ", "");
		return s;
	}

	static String wandleTop(String s, String[] liste){
		s = " " + s + " ";
		for(int i = 0; i < liste.length; i++){
			Pattern pattern = Pattern.compile("\\W"+liste[i]+"\\W");
	        Matcher matcher = pattern.matcher(s);
	        String t = "";
			int k = 0;
		    while(matcher.find(k)){
		    	t = t + s.substring(k, matcher.start()+1) + "top." + liste[i];
		    	k = matcher.end()-1;
		    }
		    t = t + s.substring(k);
		    s = t;
		}
		return s.trim();		
	}
	
	/*static String wandleTop(int i){
		return wandleTop(""+i);
	}
	
	static String wandleTop(String s){
		s = wandleTop(s, werte[0]);
		s = wandleTop(s, folgewerte);
		s = wandleTop(s, talente[0]);
		s = wandleTop(s, variablen);
		return s;
	}*/
	
	static String fuelleDreistellig(String zahl){
		if(zahl.length() < 2){
			zahl = "00"+zahl;
		}else if(zahl.length() < 3){
			zahl = "0"+zahl;
		}
		return zahl;
	}

	static String fuelleDreistellig(int n){
		String zahl = n + "";
		if(zahl.length() < 2){
			zahl = "00"+zahl;
		}else if(zahl.length() < 3){
			zahl = "0"+zahl;
		}
		return zahl;
	}
	
	static String wandleZeilenumbrueche(String s) {
		String ausgabe = "";
		int k = s.indexOf("<br>");
		int i = (k<86 && k!=-1 ? k : s.lastIndexOf(" ", 90));
		for(; i != -1;) {
			if(k < 86 && k != -1) {
				ausgabe = ausgabe + "					" + s.substring(0, i+4) + "\r\n";
				s = s.substring(i+4);
			} else {
				ausgabe = ausgabe + "					" + s.substring(0, i) + "\r\n";
				s = s.substring(i+1);
			}
			k = s.indexOf("<br>");
			i = (k<86 && k!=-1 ? k : s.lastIndexOf(" ", 90));
		}
		ausgabe = ausgabe + "					" + s;
		return ausgabe;
	}

	String setzeStart(String zeile){
		String start = "";
		zeile = zeile.trim().substring(2, zeile.length()-2);
		String [] param = zeile.split(";");
		if(param[0].equals("PROBE") || param[0].startsWith("TEXT") || param[0].startsWith("LINK") || param[0].equals("KAMPF") || param[0].equals("REGENERATION") || param[0].equals("GELD") || param[0].startsWith("WERT") || param[0].startsWith("LEP") || param[0].startsWith("SP") ||param[0].startsWith("WAFFENSCHADEN") || param[0].startsWith("AP")){
			start = "   " + param[0] + "();" + System.getProperty("line.separator");
		}				
		return start;
	}
	
	void setzeAnfangAbschnitt(String zeile){
		anfang = zeile.trim().split("\r\n");
		anfang[1] = wandleZeilenumbrueche(anfang[1]+"<br>");
	}
	
	void setzeHeldAbschnitt(String zeile){
		held = zeile.trim().split("\r\n");
		held[1] = wandleZeilenumbrueche(held[1]+"<br>");
	}
	
	void setzeEndeAbschnitt(String zeile){
		ende = zeile.trim().split("\r\n");		
	}
	
	boolean setzeSkript(String zeile, Abschnitt a){
		boolean skript = true;
		zeile = zeile.trim();
		zeile = zeile.substring(2, zeile.length()-2);
		String [] param = zeile.split(";");
		if(param[0].equals("PROBE")){
		//Unterscheidung zwischen Eigenschaftsprobe (5-6 Parameter) und Talentprobe (8-11 Parameter)	
			switch(param.length){
				case  5:;
				case  6: skript = setzeEigenschaftsprobeskript(param, a); break;
				case  8:;
				case  9:;
				case 10:;
				case 11: skript = setzeTalentprobeskript(param, a); break;
			}
		}else if(param[0].startsWith("TEXT")){
			skript = setzeTextskript(param, a);
		}else if(param[0].startsWith("LINK")){
			skript = setzeLinkskript(param, a);
		}else if(param[0].equals("KAMPF")){
			skript = setzeKampfskript(param, a);
		}else if(param[0].equals("REGENERATION")){
			skript = setzeRegenerationskript(param, a);
		}else if(param[0].equals("GELD")){
			skript = setzeGeldskript(param, a);
		}else if(param[0].startsWith("WERT")){
			skript = setzeWertskript(param, a);
		}else if(param[0].startsWith("LEP")){
			skript = setzeLePskript(param, a);
		}else if(param[0].startsWith("SP")){
			skript = setzeSPskript(param, a);
		}else if(param[0].startsWith("AP")){
			skript = setzeAPskript(param, a);
		}else if(param[0].startsWith("WAFFENSCHADEN")){
			skript = setzeWaffenschadenskript(param, a);
		}
		return skript;
	}
	
	//komplett ersetzen durch die Klassen?
	String setzeBaustein(String zeile, int nr){
		String baustein = "";
		zeile = zeile.trim().substring(2, zeile.length()-2);
		String [] param = zeile.split(";");
		if(param[0].equals("PROBE")){
			switch(param.length){
				case  5:;
				case  6: baustein = setzeProbewuerfel(param[1].trim(), param[2].trim(), param[3].trim(), param[4].trim(), nr); break;
				case  8:;
				case  9:;
				case 10: baustein = setzeProbewuerfel(param, nr); break;
				//case 11: baustein = setzeProbewuerfel(param[8].trim(), param[9].trim()) + System.getProperty("line.separator"); break;
			}
		}else if(param[0].startsWith("LINK")){
			baustein = setzeLinks(param, nr);
		}else if(param[0].equals("KAMPF")){
			//baustein = setzeKampftabelle(param, nr);
		}
		return baustein;
	}
	
	String ersetzeMarkierung(String zeile, int nr){
		for(int i = zeile.indexOf("{"); i != -1; i = zeile.indexOf("{", i+1)){
			int j = zeile.indexOf("}", i);
			String mark = zeile.substring(i+1, j);
			String end = "</span>";
			StringBuffer ersatz = new StringBuffer(zeile);
			if(mark.endsWith("/")){
				end = "";
				mark = mark.substring(0, mark.length()-1);
			}
			if(mark.startsWith("/"))
				ersatz.replace(i, j+1, "</span>");
			else
				ersatz.replace(i, j+1, "<span id=\""+mark+nr+"\">"+end);
			zeile = ersatz.toString();
		}
		return zeile;
	}
	
	boolean setzeEigenschaftsprobeskript(String param[], Abschnitt a){
		Eigenschaftsprobe e = new Eigenschaftsprobe(param, a.nr);
		a.setzeSkript(e);
		a.setzeNachfolger(abschnitte[e.gelungen], "Gelungen", true);
		a.setzeNachfolger(abschnitte[e.misslungen], "Misslungen", true);
		return true;
	}
	
	boolean setzeTalentprobeskript(String param[], Abschnitt a){
		Talentprobe t = new Talentprobe(param, a.nr);
		a.setzeSkript(t);
		a.setzeNachfolger(abschnitte[t.gelungen], "Gelungen", true);
		a.setzeNachfolger(abschnitte[t.misslungen], "Misslungen", true);
		if(t.verweigern)
			a.setzeNachfolger(abschnitte[t.wedernoch], "Verweigern", true);
		return true;
	}
	
	String setzeProbewuerfel(String eigenschaft, String mod, String positivlink, String negativlink, int nr){
		
		//if(abschnitt != null){
		//	link = "<a href=\""+fuelleDreistellig(abschnitt)+".html\">"+linktext+" ["+abschnitt+"]</a><br>" + System.getProperty("line.separator");
		//}
		String text = "				\r\n" +
					  "				<br>\r\n" +
					  "				"+eigenschaft+": <span id=\"fw"+nr+"\"></span>\r\n" + 	
					  "				<h3>Probe<span id=\"mod"+nr+"\"></span></h3>\r\n" +					  
					  "				\r\n" +
					  "				<table align=\"center\" width=60%>\r\n" + 
					  "					<tr>\r\n" + 
					  "						<td><span id=\"e1a"+nr+"\"></span><b> <span id=\"ew1a"+nr+"\"></span></b></td>\r\n" +
		              "					</tr>\r\n" +
		              "					<tr>\r\n" +
		              "						<td class=\"wuerfel1\" id=\"w1a"+nr+"\"></td>\r\n" +
		              "					</tr>\r\n" +
		              "					<tr><td>&nbsp;</td></tr>\r\n" +
		              "					<tr>\r\n" +
		              "						<td colspan=5><input type=\"button\" id=\"probebutton"+nr+"\" value=\" Wrfeln! \" onfocus=\"blur()\" onclick=\"wuerfelE("+nr+", "+mod+")\"></td>\r\n" +
		              "					</tr>\r\n" +
		              "				</table>\r\n" +
		              "				<div id=\"LINK"+nr+"positiv\" style=\"display: none\">\r\n" +
		              "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+positivlink+"').click(); setzeText("+nr+", "+positivlink+")\">Gelungen. ["+positivlink+"]</button>\r\n" +
		              "				</div>\r\n" +
		              "				<div id=\"LINK"+nr+"negativ\" style=\"display: none\">\r\n" +
		              "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+negativlink+"').click(); setzeText("+nr+", "+negativlink+")\">Misslungen. ["+negativlink+"]</button>\r\n" +
		              "				</div>\r\n";
		return text;
	}
	
	String setzeProbewuerfel(){
		return null;
	//	return setzeProbewuerfel(null, null);
	}
	
	String setzeProbewuerfel(String[] param, int nr){		
		
		String talent = param[1];
		String mod = param[2];
		String positivlink = param[6];
		String negativlink = param[7];
		String wedernochlink = "";
		String wedernochtext = "";
		if(param.length > 9) {
			wedernochlink = param[8];
			wedernochtext = param[9];
		}
		
		
		String text = "				\r\n" +
					  "				<br>\r\n" +
					  "				"+talent+": <span id=\"fw"+nr+"\"></span>\r\n" + 	
					  "				<h3>Probe<span id=\"mod"+nr+"\"></span></h3>\r\n" +					  
					  "				\r\n" +
					  "				<table align=\"center\" width=60%>\r\n" + 
					  "					<tr>\r\n" + 
					  "						<td><span id=\"e1a"+nr+"\"></span><b> <span id=\"ew1a"+nr+"\"></span></b></td>\r\n" +
					  "						<td></td>\r\n" +
					  "						<td><span id=\"e2a"+nr+"\"></span><b> <span id=\"ew2a"+nr+"\"></span></b></td>\r\n" +
					  "						<td></td>\r\n" +
					  "						<td><span id=\"e3a"+nr+"\"></span><b> <span id=\"ew3a"+nr+"\"></span></b></td>\r\n" +
		              "					</tr>\r\n" +
		              "					<tr>\r\n" +
		              "						<td class=\"wuerfel1\" id=\"w1a"+nr+"\"></td>\r\n" +
		              "							<td></td>\r\n" +
		              "						<td class=\"wuerfel2\" id=\"w2a"+nr+"\"></td>\r\n" +
		              "							<td></td>\r\n" +
		              "						<td class=\"wuerfel3\" id=\"w3a"+nr+"\"></td>\r\n" +
		              "					</tr>\r\n" +
		              "					<tr><td>&nbsp;</td></tr>\r\n" +
		              "					<tr>\r\n" +
		              "						<td colspan=5><input type=\"button\" id=\"probebutton"+nr+"\" value=\" Wrfeln! \" onfocus=\"blur()\" onclick=\"FW"+nr+" = wuerfel("+nr+", "+mod+"); QS"+nr+" = gibQS(FW"+nr+");"+(param.length > 9?" setzeLinkAus('LINK"+nr+"wedernoch"+"');":"")+"\"></td>\r\n" +
		              "					</tr>\r\n" +
		              "				</table>\r\n" +
		              "				<div id=\"LINK"+nr+"positiv\" style=\"display: none\">\r\n" +
		              "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+positivlink+"').click(); setzeText("+nr+", "+positivlink+")\">Gelungen. ["+positivlink+"]</button>\r\n" +
		              "				</div>\r\n" +
		              "				<div id=\"LINK"+nr+"negativ\" style=\"display: none\">\r\n" +
		              "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+negativlink+"').click(); setzeText("+nr+", "+negativlink+")\">Misslungen. ["+negativlink+"]</button>\r\n" +
		              "				</div>\r\n";
		              if(param.length > 9) {
		            	  text = text + 
		            			  "				<div id=\"LINK"+nr+"wedernoch\" style=\"display: block\">\r\n" +
		     		              "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+wedernochlink+"').click(); setzeText("+nr+", "+wedernochlink+")\">"+wedernochtext+" ["+wedernochlink+"]</button>\r\n" +
		     		              "				</div>\r\n";
		              }
		return text;
	}
	
	boolean setzeTextskript(String[] param, Abschnitt a){
		Text t = new Text(param, a.nr);
		a.setzeSkript(t);
		
		return true;
	}
	
	boolean setzeLinkskript(String[] param, Abschnitt a){
		Link l = new Link(param, a.nr);
		a.setzeSkript(l);
		for(int i = 0; i < l.laenge; i++){
			System.out.println(a.nr);
			a.setzeNachfolger(abschnitte[wandleZahl(l.links[i][1])], l.links[i][2], true);
		}
		return true;
	}	
	
	boolean setzeKampfskript(String[] param, Abschnitt a){
		Kampf k = new Kampf(param, a.nr);
		a.setzeSkript(k);
		a.setzeNachfolger(abschnitte[k.sieg], k.textSieg, true);
		a.setzeNachfolger(abschnitte[k.niederlage], k.textNiederlage, true);
		return true;
	}

	boolean setzeRegenerationskript(String[] param, Abschnitt a){
		Regeneration r = new Regeneration(param, a.nr);
		a.setzeSkript(r);
		return true;
	}
	
	boolean setzeGeldskript(String[] param, Abschnitt a){
		Geld g = new Geld(param, a.nr);
		a.setzeSkript(g);
		return true;
	}
		
	boolean setzeWertskript(String[] param, Abschnitt a){
		Wert w = new Wert(param, a.nr);
		a.setzeSkript(w);
		return true;
	}
	
	boolean setzeLePskript(String[] param, Abschnitt a){
		LeP l = new LeP(param, a.nr);
		a.setzeSkript(l);
		return true;
	}
	
	boolean setzeSPskript(String[] param, Abschnitt a){
		SP s = new SP(param, a.nr);
		a.setzeSkript(s);
		return true;
	}
	
	boolean setzeAPskript(String[] param, Abschnitt a){
		AP ap = new AP(param);
		a.setzeSkript(ap);
		gesamtpunkte = gesamtpunkte + ap.punkte;
		return true;
	}
	
	boolean setzeWaffenschadenskript(String[] param, Abschnitt a){
		Waffenschaden ws = new Waffenschaden(param, a.nr);
		a.setzeSkript(ws);		
		return true;
	}
                      
	String setzeLinks(String[] param, int nr){
		String text = "";
		for(int n = 1, i = 1; i < param.length; i=i+3, n++) {
			if(i+2 < param.length) {
				text = text + "				<div id=\""+param[0]+"_"+nr+"_"+n+"\" style=\"display: none\">\r\n";
				text = text + "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+param[i+1]+"').click(); setzeText("+nr+", "+param[i+1]+")\">"+param[i+2]+" ["+param[i+1]+"]</button>\r\n";
				text = text + "				</div>\r\n";
			}else {
				text = text + "				<div id=\""+param[0]+"_"+nr+"_"+n+"\" style=\"display: none\">\r\n";
				text = text + "					<button class=\"buttonlink\" onclick=\"document.getElementById('button"+param[i]+"').click(); setzeText("+nr+", "+param[i]+")\">"+param[i+1]+" ["+param[i]+"]</button>\r\n";
				text = text + "				</div>\r\n";
			}
		}
		return text;
	}
	
	boolean setzeTalente(String s){
		int anzahl = 0;
		
		for(int y = 0, x = 0; y != -1; x = y+1){
			y = s.indexOf(";", x+1);
			if(y != -1){
				anzahl++;
			}
		}
		
		talente = new String[2][anzahl];
		
		String talent = "";
		for(int y = 0, x = 0, i = 0; y != -1; x = y+1, i++){
			y = s.indexOf(";", x+1);
			if(y != -1){
				talent = s.substring(x, y).trim();
				if(talent.endsWith("(boolean)")){
					talente[0][i] = talent.substring(0, talent.lastIndexOf("(")).trim();
					talente[1][i] = "boolean";
				}else{
					if(talent.endsWith("(Stufe)")){
						talente[0][i] = talent.substring(0, talent.lastIndexOf("(")).trim();
						talente[1][i] = "Stufe";
					}else {
						talente[0][i] = talent;
						talente[1][i] = "int";
					}
				}
			}
		}	
		return true;
	}
	
	boolean setzeVariablen(String s){
		int anzahl = 0;
		
		for(int y = 0, x = 0; y != -1; x = y+1){
			y = s.indexOf(";", x+1);
			if(y != -1){
				anzahl++;
			}
		}
		
		variablen = new String[anzahl];
	
		String var = "";
		for(int y = 0, x = 0, i = 0; y != -1; x = y+1, i++){
			y = s.indexOf(";", x+1);
			if(y != -1){
				var = s.substring(x, y).trim();
				variablen[i] = wandleString(var);
			}
		}
		return true;
	}
	
	public String toString(){
		String s = "";
		for(int i = 1; i < abschnitte.length; i++){
			s = s + abschnitte[i].nr;
			
			if(abschnitte[i].gebraucht && !abschnitte[i].da){
				s = s + " wird bentigt von ";
				for(int k = 0; k < abschnitte[i].vorgaenger.length; k++){
					s = s + "[" + abschnitte[i].vorgaenger[k].nr + "]";
				}
				s = s + ".";
			}
			if(!abschnitte[i].gebraucht && !abschnitte[i].da){
				s = s + " ist frei.";
			}
			if(!abschnitte[i].gebraucht && abschnitte[i].da){
				s = s + " ist ohne Vorgnger";
			}
			if(abschnitte[i].nachfolger != null){
				s = s + ": ";
				for(int j = 0; j < abschnitte[i].nachfolger.length; j++){
					s = s + "[" + abschnitte[i].nachfolger[j].nr + "]";
				}
			}
			if(abschnitte[i].skripte != null){
				s = s + " ";
				for(Skript akt = abschnitte[i].skripte; akt != null; akt = akt.f){
					s = s + "(" + akt.toString() + ")";
				}
			}
			s = s + "\n";
		}
		s = s + "Gesamtpunkte: " + gesamtpunkte;
		return s;
	}

	boolean liesDatei(String datei){
		this.io = new IO();
		StringBuffer sb = io.liesDatei(datei);
		String s;
		s = sb.substring(0, sb.indexOf("#"));
		this.name = s.trim();
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		setzeTalente(s);		
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		setzeVariablen(s);		
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		setzeAnfangAbschnitt(s);		
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		setzeHeldAbschnitt(s);		
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		setzeEndeAbschnitt(s);		
		sb.delete(0, sb.indexOf("#")+2);
		
		s = sb.substring(0, sb.indexOf("#"));
		int n = wandleZahl(s.trim());
		if(n != -1){
			abschnitte = new Abschnitt[n+1];
			for(int i = 0; i < abschnitte.length; i++){
				abschnitte[i] = new Abschnitt(i);
			}
		}
		sb.delete(0, sb.indexOf("#")+2);
		
		for(; sb.indexOf("#") != -1;){
			s = sb.substring(0, sb.indexOf("#"));
			System.out.println(s);
			int nr = wandleZahl((s.substring(0, s.indexOf(System.getProperty("line.separator")))));
			s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
			String start = "";
			String text = "";
			String bausteine = "";
			String links = "";
			for(boolean e = false;!e;){
				String zeile = s.substring(0, s.indexOf(System.getProperty("line.separator")));
				zeile = ersetzeMarkierung(zeile, nr);
				if(zeile.indexOf("[") == -1){
					text = text + zeile + "<br>";
					s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
				}else{
					e = true;
				}
			}
			for(boolean e = false;!e;){
				if(!s.equals("")){
					String zeile = s.substring(0, s.indexOf(System.getProperty("line.separator")));
					zeile = ersetzeMarkierung(zeile, nr);
					if(zeile.indexOf("[[") != -1){
						start = start + setzeStart(zeile);
						setzeSkript(zeile, abschnitte[nr]);
						//alt, zu ersetzen mit abschnitte[nr].setzeBausteine()?
						bausteine = bausteine + setzeBaustein(zeile, nr);
						s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
					}else if(zeile.indexOf("[") != -1){
						links = links + zeile + System.getProperty("line.separator");
						s = s.substring(s.indexOf(System.getProperty("line.separator"))+2, s.length());
					}else{
						e = true;
					}
				}else
					e = true;
			}
			sb.delete(0, sb.indexOf("#")+2);
			abschnitte[nr].start = start;
			abschnitte[nr].text = text;
			abschnitte[nr].bausteine = abschnitte[nr].bausteine + bausteine;
			abschnitte[nr].da = true;

			for(int x = 0; links.length() != 0;){
				String href = "";
				x = links.indexOf(System.getProperty("line.separator"));
				if(x != -1){
					if(links.indexOf("[") != -1){
						href = links.substring(links.indexOf("[")+1, links.indexOf("]"));
						int folge = wandleZahl(href);
						if(folge != -1)							
							abschnitte[nr].setzeNachfolger(abschnitte[folge], links.substring(0, x), false);
						else
							abschnitte[nr].setzeNachfolger(href, links.substring(0, x), false);
					}
					links = links.substring(x+2);
				}
			}
		}
		return true;
	}
	
	boolean schreibeAbschnitte(){
		return schreibeAbschnitte(1, abschnitte.length-1);
	}
	
	boolean schreibeAbschnitte(int von, int bis){
		for(int nr = von; nr <= bis; nr++){
			if(abschnitte[nr].da){
	
				io.schreibeZeile("			<div id=\""+nr+"\" style=\"display: none\">");
				String skriptzeile = "				<button id=\"button"+nr+"\" onclick=\"setzeAbschnitt("+nr+");";
				for(Skript sk = abschnitte[nr].skripte; sk != null; sk = sk.f) {
			        skriptzeile = skriptzeile + sk.gibSkript();					
				}
				skriptzeile = skriptzeile + "\" style=\"display: none\"></button>";
				io.schreibeZeile(skriptzeile);				
				io.schreibeZeile("				<table align=\"center\"><tr><td class=\"ue"+(nr < 10?"x":nr < 100?"xx":"xxx")+(nr%2+1)+"\">");
				io.schreibeZeile("					"+nr);
				io.schreibeZeile("				</td></tr></table>");
				io.schreibeZeile("				<p>");
				io.schreibeZeile(wandleZeilenumbrueche(abschnitte[nr].text));
				io.schreibeZeile("				</p>");
				//io.schreibeZeile();
				
				io.schreibeZeile(abschnitte[nr].gibBausteine());
				
				if(abschnitte[nr].nachfolger != null){
					boolean text = false;
					for(int i = 0; i < abschnitte[nr].nachfolger.length;i++){
						if(!abschnitte[nr].bedingung[i]){
							String ziel = "";
							if(abschnitte[nr].nachfolger[i].nr != -1) {
								ziel = ""+abschnitte[nr].nachfolger[i].nr;
							}else {
								ziel = abschnitte[nr].nachfolger[i].bez;
								text = true;
							}
							io.schreibeZeile("				<button class=\"buttonlink\" onclick=\"document.getElementById('button"+ziel+"').click(); setzeText("+nr+", "+(text?"'"+ziel+"'":ziel)+")\">"+abschnitte[nr].links[i]+"</button><br>");
						}
					}
				}
				io.schreibeZeile("			</div>");
				io.schreibeZeile();				
			}
		}	
		return true;
	}
	
	boolean schreibeEnde() {
		io.schreibeZeile("			<div id=\"Ende\" style=\"display: none\">");
		io.schreibeZeile("				<button id=\"buttonEnde\" onclick=\"gibBelohnung('"+ende[1]+"'); gibAPs();\" style=\"display: none\"></button>");
		io.schreibeZeile("				<h3>Ein Soloabenteuer fr Das Schwarze Auge");
		io.schreibeZeile("				<br>");
		io.schreibeZeile("				<br>");
		io.schreibeZeile("				<img src=\"../Bilder/Ende.png\" alt=\"\" border=\"0\"></h3>");
		io.schreibeZeile("				<b>Du hast das Abenteuer zu <span id=\"prozent\"></span> % gelst.");
		io.schreibeZeile("				Dafr bekommst du insgesamt <span id=\"gesamtAP\"></span></b>");
		io.schreibeZeile("				<br><br>");
		io.schreibeZeile("				<div id=\"EndeAP\"></div>");
		io.schreibeZeile("				<br>");
		io.schreibeZeile("				<div id=\"Zusatz\"></div>");
		io.schreibeZeile("				<br>");
		io.schreibeZeile("				<br>");
		io.schreibeZeile("				<p class=\"center\">&raquo;<a href=\"Versionshistorie.html\">"+name+"</a>&laquo;<br>");
		io.schreibeZeile("					"+anfang[0]+"<br><br>");
		io.schreibeZeile("					<br><br>");
		io.schreibeZeile("					<button class=\"buttonlink\" onclick=\"document.getElementById('buttonFragebogen').click(); setzeText('Ende', 'Fragebogen')\">[Zum Fragebogen]</button>");
		io.schreibeZeile("					<br><br>");
		io.schreibeZeile("					<a class=\"buttonlink\" target=\"_top\" href=\"../../index.html\" onFocus=\"this.blur()\">[Neuanfang]</a>");
		io.schreibeZeile("				</p>");
		io.schreibeZeile("			</div>");
		return true;		
	}
	
	boolean schreibeFragebogen() {
		io.schreibeZeile("			<div id=\"Fragebogen\" style=\"display: none\">");
		io.schreibeZeile("				<button id=\"buttonFragebogen\" onclick=\"gibWerteFragebogen(); gibFragenFragebogen();\" style=\"display: none\"></button>");
		io.schreibeZeile("				<h2>Der Fragebogen zu "+name+"</h2>");
		io.schreibeZeile("				<p>");
		io.schreibeZeile("					Bitte sei so nett und beantworte alle Fragen wahrheitsgem mit einer Schulnote von 1 bis 6. Je nach Verlauf des Abenteuers");
		io.schreibeZeile("					kannst du vielleicht mit der Frage nichts anfangen. Dann lass das Feld einfach leer.<br>");
		io.schreibeZeile("					Zu jeder Frage kannst du zustzlich eine Anmerkung machen.");
		io.schreibeZeile("					<br>");
		io.schreibeZeile("				</p>");
		io.schreibeZeile("				<br>");
		io.schreibeZeile("				<form action=\"https://dsa-solo.de/Daten/FragebogenSend.php\" method=\"POST\">");
		io.schreibeZeile("  				<table border=0 align=\"left\" id=\"table\">");
		io.schreibeZeile("      				<tr>");
		io.schreibeZeile("     						<td class=\"center\" colspan=3><b>Allgemeine Fragen</b></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\">&middot;</td>");
		io.schreibeZeile("      					<td class=\"left\">Wie hat dir das Abenteuer gefallen?</td>");
		io.schreibeZeile("      					<td class=\"right\"><input name=\"Abenteuer\" type=\"text\" size=\"1\" maxlength=\"1\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\"></td>");
		io.schreibeZeile("      					<td class=\"left\" colspan=2>Anmerkungen: <input name=\"Abenteuer Anm\" type=\"text\" size=\"90\" maxlength=\"300\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\">&middot;</td>");
		io.schreibeZeile("      					<td class=\"left\">Wie findest du den Titel?</td>");
		io.schreibeZeile("      					<td class=\"right\"><input name=\"Titel\" type=\"text\" size=\"1\" maxlength=\"1\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\"></td>");
		io.schreibeZeile("      					<td class=\"left\" colspan=2>Anmerkungen: <input name=\"Titel Anm\" type=\"text\" size=\"90\" maxlength=\"300\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\">&middot;</td>");
		io.schreibeZeile("      					<td class=\"left\">Wie findest du das Layout (Farben, Schriftart, Anordnung der Werte und Links)?</td>");
		io.schreibeZeile("      					<td class=\"right\"><input name=\"Layout\" type=\"text\" size=\"1\" maxlength=\"1\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\"></td>");
		io.schreibeZeile("      					<td class=\"left\" colspan=2>Anmerkungen: <input name=\"Layout Anm\" type=\"text\" size=\"90\" maxlength=\"300\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\">&middot;</td>");
		io.schreibeZeile("      					<td class=\"left\">Wie gefllt dir die Geschichte, der Handlungsstrang des Abenteuers?</td>");
		io.schreibeZeile("      					<td class=\"right\"><input name=\"Geschichte\" type=\"text\" size=\"1\" maxlength=\"1\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\"></td>");
		io.schreibeZeile("      					<td class=\"left\" colspan=2>Anmerkungen: <input name=\"Geschichte Anm\" type=\"text\" size=\"90\" maxlength=\"300\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\">&middot;</td>");
		io.schreibeZeile("      					<td class=\"left\">Wie findest du das Konzept eines Soloabenteuers als Browserspiel?</td>");
		io.schreibeZeile("      					<td class=\"right\"><input name=\"Konzept\" type=\"text\" size=\"1\" maxlength=\"1\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\"></td>");
		io.schreibeZeile("      					<td class=\"left\" colspan=2>Anmerkungen: <input name=\"Konzept Anm\" type=\"text\" size=\"90\" maxlength=\"300\"></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\">&middot;</td>");
		io.schreibeZeile("      					<td class=\"left\">Welche Fehler sind dir aufgefallen, mgen sie noch so klein und unbedeutend sein?</td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"right\" valign=\"top\"></td>");
		io.schreibeZeile("      					<td class=\"left\" colspan=2><textarea name=\"Fehler\" rows=\"5\" cols=\"80\"></textarea></td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td class=\"center\" colspan=3>&nbsp;</td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("    						<td class=\"center\" colspan=3><b>Fragen zu Abschnitten:</b> Wie haben dir die folgenden Szenen gefallen?</td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("    					<tr>");
		io.schreibeZeile("      					<td colspan=3>");
		io.schreibeZeile("        						<input type=\"submit\" value=\" Senden \">");
		io.schreibeZeile("        						<input id=\"punkte\" type=\"Hidden\" name=\"punkte\">");
		io.schreibeZeile("        						<input id=\"abschnitte\" type=\"Hidden\" name=\"abschnitte\">");
		io.schreibeZeile("      					</td>");
		io.schreibeZeile("    					</tr>");
		io.schreibeZeile("  				</table>");
		io.schreibeZeile("				</form>");
		io.schreibeZeile("			</div>");
		io.schreibeZeile("		</div>");
		return true;		
	}
	
	void schreibe(String dir){
		GregorianCalendar gc = new GregorianCalendar();
		
		io.setzeDatei(dir+"0.html");
		io.schreibeZeile("<!DOCTYPE html lang=\"de\">");
		io.schreibeZeile("<head>");
		io.schreibeZeile("	<meta name=\"description\"  content=\""+name+"\">");
		io.schreibeZeile("	<meta name=\"keywords\"     content=\"DSA-Solo, DSA, Rollenspiel, Das Schwarze Auge, Abenteuer, Soloabenteuer\">");
		io.schreibeZeile("	<meta name=\"author\"       content=\"Thore Bre\">");
		io.schreibeZeile("	<meta name=\"DC.Date\"      content=\"" + gc.get(Calendar.DATE) + "." + (gc.get(Calendar.MONTH)+1) + "." + gc.get(Calendar.YEAR) + "\">");
		io.schreibeZeile("	<meta name=\"DC.Language\"  content=\"de\">");
		io.schreibeZeile("	<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\">");
		io.schreibeZeile();
		io.schreibeZeile("	<title>"+name+"</title>");
		io.schreibeZeile("	<link rel=\"stylesheet\" type=\"text/css\" href=\"styles.css\">");
		io.schreibeZeile();
		io.schreibeZeile("	<script>");
		for(int i = 0; i < variablen.length; i++) {
			io.schreibeZeile("		var "+variablen[i]+" = 0;");
		}
		io.schreibeZeile("	</script>");
		io.schreibeZeile("	<script src=\"../../Scripts.js\"></script>");
		io.schreibeZeile("</head>");
		io.schreibeZeile("<body>");
		io.schreibeZeile("	<div id=\"Rahmen\" class=\"nav\">");
		io.schreibeZeile("		<h3><span id=\"rName\"></span></h3>");		
		io.schreibeZeile("		<table border=\"0\" width=100% cellpadding=\"0\" cellspacing=\"4\">");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td>Dukaten:</td>");
		io.schreibeZeile("				<td id=\"rD\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td>Silbertaler:</td>");
		io.schreibeZeile("				<td id=\"rS\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td>Heller:</td>");
		io.schreibeZeile("				<td id=\"rH\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td>&nbsp;</td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td align=\"right\">LeP:</td>");
		io.schreibeZeile("				<td id=\"rLeP\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td align=\"right\">AW:</td>");
		io.schreibeZeile("				<td id=\"rAW\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td align=\"right\">RS:</td>");
		io.schreibeZeile("				<td id=\"rRS\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td align=\"right\">BE:</td>");
		io.schreibeZeile("				<td id=\"rBE\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td align=\"right\">AT:</td>");
		io.schreibeZeile("				<td id=\"rAT\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("			<tr>");
		io.schreibeZeile("				<td align=\"right\">PA:</td>");
		io.schreibeZeile("				<td id=\"rPA\"></td>");
		io.schreibeZeile("			</tr>");
		io.schreibeZeile("		</table>");
		io.schreibeZeile("	</div>");
		io.schreibeZeile();
		io.schreibeZeile("	<div id=\"Inhalt\" class=\"inhalt\">");
		io.schreibeZeile("		<a href=\"../../index.html\"><header>"+name+"</header></a>");
		io.schreibeZeile();
		io.schreibeZeile("		<div id=\"Anfang\">");
		io.schreibeZeile("			<h2>"+anfang[0]+"</h2>");
		io.schreibeZeile("			<p>");
		io.schreibeZeile(anfang[1]);
		io.schreibeZeile("			</p>");
		io.schreibeZeile();
		io.schreibeZeile("			<p class=\"center\">");
		io.schreibeZeile("				<button class=\"buttonlink\" onclick=\"setzeText('Anfang', 'Held')\">Mein Held!</button><br>");
		io.schreibeZeile("			</p>");
		io.schreibeZeile("		</div>");
		io.schreibeZeile();
		io.schreibeZeile("		<div id=\"Held\" style=\"display: none\">");
		io.schreibeZeile("			<h2>"+held[0]+"</h2>");
		io.schreibeZeile("			<p>");
		io.schreibeZeile(held[1]);
		io.schreibeZeile("			</p>");
		io.schreibeZeile("			<form name=\"F\" method=\"post\" onsubmit=\"return !!(sub() & setzeRahmen())\">");
		io.schreibeZeile("				<div class=\"row\">");
		io.schreibeZeile("					<div class=\"col-25\"><label for=\"vorname\">Vorname:</label></div>");
		io.schreibeZeile("					<div class=\"col-75\"><input name=\"vorname\" value=\""+held[2]+"\" type=\"text\" tabindex=\"1\" size=\"30\" maxlength=\"60\"></div>");
		io.schreibeZeile("				</div>");
		io.schreibeZeile("				<div class=\"row\">");
		io.schreibeZeile("					<div class=\"col-25\"><label for=\"nachname\">Nachname:</label></div>");
		io.schreibeZeile("					<div class=\"col-75\"><input name=\"nachname\" value=\""+held[3]+"\" type=\"text\" tabindex=\"2\" size=\"30\" maxlength=\"60\"></div>");
		io.schreibeZeile("				</div>");
		io.schreibeZeile("				<br>");
		io.schreibeZeile("				<fieldset>");
		io.schreibeZeile("				<legend>Geld</legend>");
		io.schreibeZeile("				<div class=\"row\">");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<input name=\"D\" value=\"4\" type=\"text\" tabindex=\"3\" size=\"1\" maxlength=\"3\">");
		io.schreibeZeile("						<label for=\"D\">Dukaten,</label>");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<input name=\"S\" value=\"10\" type=\"text\" tabindex=\"4\" size=\"1\" maxlength=\"3\">");
		io.schreibeZeile("						<label for=\"S\">Silbertaler,</label>");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<input name=\"H\" value=\"9\" type=\"text\" tabindex=\"5\" size=\"1\" maxlength=\"3\">");
		io.schreibeZeile("						<label for=\"H\">Heller</label>");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("				</div>");
		io.schreibeZeile("				</fieldset>");
		io.schreibeZeile("				<fieldset>");
		io.schreibeZeile("				<legend>Eigenschaften</legend>");
		io.schreibeZeile("				<div class=\"row\">");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"MU\">MU</label>");
		io.schreibeZeile("						<input name=\"MU\" value=\""+held[4]+"\" type=\"text\" tabindex=\"6\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"KL\">KL</label>");
		io.schreibeZeile("						<input name=\"KL\" value=\""+held[5]+"\" type=\"text\" tabindex=\"7\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"IN\">IN</label>");
		io.schreibeZeile("						<input name=\"IN\" value=\""+held[6]+"\" type=\"text\" tabindex=\"8\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"CH\">CH</label>");
		io.schreibeZeile("						<input name=\"CH\" value=\""+held[7]+"\" type=\"text\" tabindex=\"9\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("				</div>");
		io.schreibeZeile("				<div class=\"row\">");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"FF\">FF</label>");
		io.schreibeZeile("						<input name=\"FF\" value=\""+held[8]+"\" type=\"text\" tabindex=\"10\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"GE\">GE</label>");
		io.schreibeZeile("						<input name=\"GE\" value=\""+held[9]+"\" type=\"text\" tabindex=\"11\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"KO\">KO</label>");
		io.schreibeZeile("						<input name=\"KO\" value=\""+held[10]+"\" type=\"text\" tabindex=\"12\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("					<div class=\"col-25\">");
		io.schreibeZeile("						<label class=\"ll\" for=\"KK\">KK</label>");
		io.schreibeZeile("						<input name=\"KK\" value=\""+held[11]+"\" type=\"text\" tabindex=\"12\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("				</div>");
		io.schreibeZeile("				</fieldset>");
		io.schreibeZeile("				<fieldset>");
		io.schreibeZeile("					<legend>Abgeleitete Werte</legend>");
		io.schreibeZeile("					<div class=\"row\">");
		io.schreibeZeile("						<div class=\"col-25\">");
		io.schreibeZeile("							<label class=\"ll\" for=\"LeP\">LeP</label>");
		io.schreibeZeile("							<input name=\"LeP\" value=\""+held[12]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("						</div>");
		io.schreibeZeile("						<div class=\"col-25\">");
		io.schreibeZeile("							<label class=\"ll\" for=\"SK\">SK</label>");
		io.schreibeZeile("							<input name=\"SK\" value=\""+held[13]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("						</div>");
		io.schreibeZeile("						<div class=\"col-25\">");
		io.schreibeZeile("							<label class=\"ll\" for=\"ZK\">ZK</label>");
		io.schreibeZeile("							<input name=\"ZK\" value=\""+held[14]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("						</div>");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("				</fieldset>");
		io.schreibeZeile("				<fieldset>");
		io.schreibeZeile("					<legend>Kampfwerte</legend>");
		io.schreibeZeile("						<div class=\"row\">");
		io.schreibeZeile("							<div class=\"col-25\">");
		io.schreibeZeile("								<label class=\"ll\" for=\"AT\">AT</label>");
		io.schreibeZeile("								<input name=\"AT\" value=\""+held[15]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("							</div>");
		io.schreibeZeile("							<div class=\"col-25\">");
		io.schreibeZeile("								<label class=\"ll\" for=\"PA\">PA</label>");
		io.schreibeZeile("								<input name=\"PA\" value=\""+held[16]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("							</div>");
		io.schreibeZeile("							<div class=\"col-25\">");
		io.schreibeZeile("								<label class=\"ll\" for=\"AW\">AW</label>");
		io.schreibeZeile("								<input name=\"AW\" value=\""+held[17]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("							</div>");
		io.schreibeZeile("						</div>");
		io.schreibeZeile("						<div class=\"row\">");
		io.schreibeZeile("							<div class=\"col-25\">");
		io.schreibeZeile("								<label class=\"ll\" for=\"RS\">RS</label>");
		io.schreibeZeile("								<input name=\"RS\" value=\""+held[18]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("							</div>");
		io.schreibeZeile("							<div class=\"col-25\">");
		io.schreibeZeile("								<label class=\"ll\" for=\"BE\">BE</label>");
		io.schreibeZeile("								<input name=\"BE\" value=\""+held[19]+"\" type=\"text\" size=\"1\" maxlength=\"2\">");
		io.schreibeZeile("							</div>");
		io.schreibeZeile("							<div class=\"col-50\">");
		io.schreibeZeile("								<label class=\"ll\" for=\"wuerfelTP\">TP</label>");
		io.schreibeZeile("								<input name=\"wuerfelTP\" value=\""+held[20]+"\" type=\"text\" tabindex=\"13\" size=\"1\" maxlength=\"1\">W6 +");
		io.schreibeZeile("								<input name=\"zusatzTP\" value=\""+held[21]+"\" type=\"text\" tabindex=\"13\" size=\"1\" maxlength=\"1\">");
		io.schreibeZeile("							</div>");
		io.schreibeZeile("						</div>");
		io.schreibeZeile("					</fieldset>");
		io.schreibeZeile("					<fieldset>");
		io.schreibeZeile("						<legend>Talente</legend>");
		
		int i = 0;
		int spalte = 0;
		for(; i < talente[0].length && talente[1][i].equals("int"); i++, spalte++){
			if(spalte%2 == 0) {
				io.schreibeZeile("						<div class=\"row\">");
			}
			io.schreibeZeile("							<div class=\"col-25\"><label for=\""+wandleString(talente[0][i])+"\">"+talente[0][i]+"</label></div>");
			io.schreibeZeile("							<div class=\"col-25\"><input name=\""+wandleString(talente[0][i])+"\" value=\""+held[22+i]+"\" type=\"text\" size=\"2\" maxlength=\"3\"></div>");
			if(spalte%2 == 1) {
				io.schreibeZeile("						</div>");
			}
		}
		if(spalte%2 == 1) {
			io.schreibeZeile("						</div>");
		}
		io.schreibeZeile("					</fieldset>");
		io.schreibeZeile("					<fieldset>");
		io.schreibeZeile("						<legend>Sonderfertigkeiten, Sprachen/Schriften</legend>");
		
		spalte = 0;
		for(; i < talente[0].length; i++, spalte++){
			int wert = wandleZahl(held[22+i]);
			if(spalte%2 == 0) {
				io.schreibeZeile("						<div class=\"row\">");
			}
			io.schreibeZeile("							<div class=\"col-50\">");
			io.schreibeZeile("								<input type=\"checkbox\" id=\"cb"+talente[0][i]+"\" name=\"cb"+talente[0][i]+"\" value=\""+wert+"\" size=\"2\" maxlength=\"2\""+(wert>0?" checked":"")+">");
			io.schreibeZeile("								<label for=\"cb"+talente[0][i]+"\">"+talente[0][i]+"</label>");
			if(talente[1][i].equals("Stufe")) {
				io.schreibeZeile("								<input id=\"bSF"+talente[0][i]+"Minus\" type=\"button\" "+(wert==0?"disabled=\"true\" ":"")+"value=\"-\" onfocus=\"blur()\" onclick=\"setzeSFwert('SF"+talente[0][i]+"', -1)\">");
				io.schreibeZeile("								<label id=\"SF"+talente[0][i]+"\" for=\"cb"+talente[0][i]+"\">"+wandleRoemischeZahl((wert==0?1:wert))+"</label>");
				io.schreibeZeile("								<input id=\"bSF"+talente[0][i]+"Plus\" type=\"button\" "+(wert==3?"disabled=\"true\" ":"")+"value=\"+\" onfocus=\"blur()\" onclick=\"setzeSFwert('SF"+talente[0][i]+"', 1)\">");
			}
			io.schreibeZeile("						</div>");
			if(spalte%2 == 1) {
				io.schreibeZeile("						</div>");
			}
		}
		if(spalte%2 == 1) {
			io.schreibeZeile("						</div>");
		}
		
		io.schreibeZeile("					</fieldset>");
		io.schreibeZeile("					<div class=\"row\">");
		io.schreibeZeile("						<div class=\"col-50\">");
		//Hier wird ein Timeout gesetzt, weil der sub tatschlich ein bisschen lnger braucht um die Werte zu setzen als das Umschalten auf Abschnitt 1. Daher waren die Werte in Abschnitt 1 noch auf 0. Mit etwas Warten gehts.
		io.schreibeZeile("							<button class=\"buttonlink\" onclick=\"setTimeout(function myFunction() {setzeText('Held', 1);document.getElementById('button1').click();}, 150);\">Absenden</button>");
		io.schreibeZeile("							<input class=\"buttonlink\" type=\"reset\" value=\" Zurcksetzen \">");
		io.schreibeZeile("						</div>");
		io.schreibeZeile("					</div>");
		io.schreibeZeile("				</form>");					
		io.schreibeZeile("			</div>");
		
		schreibeAbschnitte();
		
		schreibeEnde();
		schreibeFragebogen();
		
		io.schreibeZeile("</body>");
		io.schreibeZeile("</html>");
		io.schliesseDatei();
	}
}
